//+------------------------------------------------------------------+
//| T3.mq4                                                           |
//| MojoFX                                                           |
//| http://groups.yahoo.com/group/MetaTrader_Experts_and_Indicators/ |
//+------------------------------------------------------------------+
#property copyright "MojoFX - Conversion only"
#property link "http://groups.yahoo.com/group/MetaTrader_Experts_and_Indicators/"
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
extern int T3_Period = 14;
extern double b = 0.7;
double MapBuffer[];
//----    
double e1[],e2[],e3[],e4[],e5[],e6[];
//----
double c1,c2,c3,c4;
double n,w1,w2,b2,b3;
//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
//---- 
SetIndexStyle(0,DRAW_LINE);
IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
IndicatorShortName("T3"+T3_Period);
SetIndexBuffer(0,MapBuffer);
//----     
IndicatorBuffers(7);
SetIndexBuffer(1,e1);
SetIndexBuffer(2,e2);
SetIndexBuffer(3,e3);
SetIndexBuffer(4,e4);
SetIndexBuffer(5,e5);
SetIndexBuffer(6,e6);
//----
b2=b*b;
b3=b2*b;
c1=-b3;
c2=(3*(b2+b3));
c3=-3*(2*b2+b+b3);
c4=(1+3*b+b3+3*b2);
n=T3_Period;
if (n<1) n=1;
n = 1 + 0.5*(n-1);
w1 = 2 / (n + 1);
w2 = 1 - w1;
//----
return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function |
//+------------------------------------------------------------------+
int start()
{
//----+         
if (Bars-1<T3_Period)return(0);
//----+        
int  MaxBar,limit,counted_bars=IndicatorCounted();
//----    
if (counted_bars<0)return(-1);
//----      
if (counted_bars>0) counted_bars--;
//----     ,        
MaxBar=Bars-1-T3_Period;
//----     ,         
limit=(Bars-1-counted_bars);
//----  
if (limit>MaxBar)
  {
   for(int bar=Bars-1; bar>=limit; bar--)MapBuffer[bar]=0.0;
   limit=MaxBar; 
  }

//+---    
for(bar=limit; bar>=0; bar--)
 {  
  e1[bar] = w1*Close[bar] + w2*e1[bar+1];
  e2[bar] = w1*e1[bar] + w2*e2[bar+1];
  e3[bar] = w1*e2[bar] + w2*e3[bar+1];
  e4[bar] = w1*e3[bar] + w2*e4[bar+1];
  e5[bar] = w1*e4[bar] + w2*e5[bar+1];
  e6[bar] = w1*e5[bar] + w2*e6[bar+1];

  MapBuffer[bar]=c1*e6[bar] + c2*e5[bar] + c3*e4[bar] + c4*e3[bar];
 } 
//+---   
return(0);
}
//+------------------------------------------------------------------+

